# EXERCISE 7.2 pag. 297 Srndal et al. 1992

# data
# sum.y<-53151
# sum.y2<-21266279
# sum.x<-757246
# sum.x2<-3638841824
# sum.xy<-264703466
# n=40
# nh<-8
# H<-5
# N=281
# pop.data<-data.frame(h=c(1,2,3,4,5),
#                      Nh=c(91,66,53,41,30),
#                      S2h.x=c(61722, 60038,105494,683674,4037601),
#                      S2h.y=c(445,792,2965,16595,78188),
#                      Sh.xy=c(4021,3326,8340,63493,360464))
# comparing the variance of the 3 estimators of the total of y
# 6780*10^7 - 12301*10^6 - 6947*10^6

# load data of the exercise
# setwd("C:/Users/Utente/OneDrive - University of Pisa/WEB PISA/Lezioni JM 2018/Lezioni II semestre SAE")
load("Ex 7_2 data.Rdata")

f<-n/N

# ESTIMATOR 1 (pag. 77-78)
# variance of y
S2.y<-(sum.y2-(sum.y)^2/N)/(N-1)
S2.y

# variance of the estimator 1
V1<-(N^2)*((1-f)/n)*S2.y
V1


# ESTIMATOR 2 (pag. 249)
# variance of X
S2.x<-(sum.x2-(sum.x)^2/N)/(N-1)
S2.x
# covariance
x.bar<-sum.x/N
y.bar<-sum.y/N

S.xy<-(sum.xy-(N*x.bar*y.bar))/(N-1)


B<-sum.y/sum.x
B2<-B^2

# variance estimator
V2<-(N^2)*((1-f)/n)*(S2.y+B2*S2.x-2*B*S.xy)


# ESTIMATOR 3 (pag. 253)
attach(pop.data)
Vh<-{}
for (i in (1:dim(pop.data)[1]))
{
Vh[i]<-(Nh[i]^2)*((1/nh)-(1/Nh[i]))*(S2h.y[i]+B2*S2h.x[i]-2*B*Sh.xy[i])
}

V3<-sum(Vh)

V1; V2; V3